#property indicator_separate_window //  
#property indicator_buffers 3
#include <includeGraphics.mqh>

//-- 
extern double period=0.5; // . (<1)   (>1) EMA
extern int History=555; // -  ; 0 - 
//--
double MAc[],MAh[],MAl[]; //  


//  
bool first=1; //   
double k; // . EMA

//=============================================================
int init()
  {
   SetIndexBuffer(0,MAc); //   EMA  Close   Close
   SetIndexStyle(0,DRAW_NONE);
   SetIndexLabel(0,NULL);

   SetIndexBuffer(1,MAh); //   EMA  Close   High
   SetIndexStyle(1,DRAW_NONE);
   SetIndexLabel(1,NULL);

   SetIndexBuffer(2,MAl); //   EMA  Close   Low
   SetIndexStyle(2,DRAW_NONE);
   SetIndexLabel(2,NULL);

//----
   _ID=GetID(); //   

   ShortName="Example";
   IndicatorShortName(ShortName); //     

   if(period>1) k=2/(period+1); //   >1,     EMA
   else k=period; // <=1 -  

   return(0);
  }

int reinit() // -  
  {
   ArrayInitialize(MAc,0.0);
   ArrayInitialize(MAh,0.0);
   ArrayInitialize(MAl,0.0);
   DelObjects();
   return(0);
  }

int deinit()
  {
   DelObjects();
   DeinitObjects();
   return(0);
  }
  
//=============================================================
int start()
  {
   
   int ic=IndicatorCounted();
   if(!first && Bars-ic-1>1) ic=reinit(); 
   bool ic0=ic==0;
   int limit=Bars-ic-1; // - 
   if(History!=0 && limit>History) limit=History-1; // -   

   for(int i=limit; i>=0; i--)
     {   
      bool reset=i==limit && ic==0; //      
      if(reset) {
         static int BarsPrev=0; // .  Bars
        }
      bool NewBar=(ic0 && i>0) || BarsPrev!=Bars; //    

      MAc[i]=k*Close[i]+(1-k)*MAc[i+1]; // EMA  Close   Close
      MAh[i]=k*High[i] +(1-k)*MAc[i+1]; // EMA  Close   High
      MAl[i]=k*Low[i]  +(1-k)*MAc[i+1]; // EMA  Close   Low
   
      int win=GetWinNumber(); //     
      if(NewBar) //  1-     , 
        {
         //  
         static string _mac,_mah,_mal; //  
         datetime t0=Time[i];
         datetime t1=Time[i+1];
         datetime xt1=xTime(i-1);
         _mac=Name("Close"); // EMA  Close   Close
         ObjectCreate(_mac,OBJ_TREND,win,t0,MAc[i],xt1,MAc[i]); // EMA  Close
         ObjectSet(_mac,OBJPROP_COLOR,Blue);
         ObjectSet(_mac,OBJPROP_RAY,0);

         _mah=Name("High"); // EMA  Close   High
         ObjectCreate(_mah,OBJ_TREND,win,t0,MAc[i],t0,MAh[i]);
         ObjectSet(_mah,OBJPROP_COLOR,Red);
         ObjectSet(_mah,OBJPROP_RAY,0);

         _mal=Name("Low");  // EMA  Close   Low
         ObjectCreate(_mal,OBJ_TREND,win,t0,MAc[i],t0,MAl[i]);
         ObjectSet(_mal,OBJPROP_COLOR,Green);
         ObjectSet(_mal,OBJPROP_RAY,0);
        }
      else //  
        {
         ObjectSet(_mac,OBJPROP_PRICE1,MAc[i]);
         ObjectSet(_mac,OBJPROP_PRICE2,MAc[i]);
      
         ObjectSet(_mah,OBJPROP_PRICE1,MAc[i]);
         ObjectSet(_mah,OBJPROP_PRICE2,MAh[i]);
      
         ObjectSet(_mal,OBJPROP_PRICE1,MAc[i]);
         ObjectSet(_mal,OBJPROP_PRICE2,MAl[i]);
        }

      // 
      if(NewBar) {BarsPrev=Bars;}
     }   
   first=0; //    
   
   return(0);
  }
//=============================================================


